<?php
use AWeberWebFormPluginNamespace as AWeberWebformPluginAlias;

/*
Plugin Name: AWeber for WordPress
Plugin URI: http://www.aweber.com/faq/questions/588/How+Do+I+Use+AWeber%27s+Webform+Widget+for+Wordpress%3F
Description: Add AWeber Sign Up Forms to your WordPress site
Version: 4.1.1
Author: AWeber
Author URI: http://www.aweber.com
License: MIT
*/


if (function_exists('register_activation_hook')) {
    if (!function_exists('aweber_web_forms_activate')) {
        function aweber_web_forms_activate() {
            if (version_compare(phpversion(), '5.6', '<')) {
                trigger_error('', E_USER_ERROR);
            }
        }
    }

    register_activation_hook(__FILE__, 'aweber_web_forms_activate');
}

if (isset($_GET['action']) and $_GET['action'] == 'error_scrape') {
    die('Sorry, AWeber Sign Up Form requires PHP 5.6 or higher. Please deactivate AWeber Sign Up Form.');
}

// Initialize plugin.
if (!class_exists('AWeberWebformPlugin')) {
    require_once(dirname(__FILE__) . '/php/aweber_api/aweber_api.php');
    require_once(dirname(__FILE__) . '/php/aweber_webform_plugin.php');
    $aweber_webform_plugin = new AWeberWebformPluginAlias\AWeberWebformPlugin();

    $options = get_option('AWeberWebformPluginWidgetOptions');

    if ($options['create_subscriber_comment_checkbox'] == 'ON' && is_numeric($options['aweber_comment_subscriber_listid']))
    {
        /* The following line adds the checkbox to the comment form.
         * If problems persist, the code can be changed to
         * any of the following 3 lines. Just add a # before
         * the line that is currently active, and remove the
         * # from the line you wish to use. */
        add_action('comment_form',array(&$aweber_webform_plugin,'add_comment_checkbox'));
        #add_filter('comment_form_after_fields',array(&$aweber_webform_plugin,'add_comment_checkbox'));
        #add_filter('thesis_hook_after_comment_box',array(&$aweber_webform_plugin,'add_comment_checkbox'));
        // End
        add_action('comment_post',array(&$aweber_webform_plugin,'grab_email_from_comment'));
    }

    if ($options['create_subscriber_registration_checkbox'] == 'ON' && is_numeric($options['aweber_register_subscriber_listid']))
    {
        add_action('register_form',array(&$aweber_webform_plugin,'add_register_checkbox'));
        add_action('register_post',array(&$aweber_webform_plugin,'grab_email_from_registration'));
    }
    add_action('comment_unapproved_to_approved',array(&$aweber_webform_plugin,'comment_approved'));
    add_action('comment_spam_to_approved',array(&$aweber_webform_plugin,'comment_approved'));
    add_action('delete_comment',array(&$aweber_webform_plugin,'comment_deleted'));
}

// Initialize admin panel.
if (!function_exists('AWeberFormsWidgetController_ap')) {
    function AWeberFormsWidgetController_ap() {
        global $aweber_webform_plugin;
        if (!isset($aweber_webform_plugin)) {
            return;
        }

        // Create AWeber top menu.
        add_menu_page('AWeber Web Form', 'AWeber', 'manage_options', 'aweber.php',
            array(&$aweber_webform_plugin, 'printAdminPage'), plugins_url('AWeber_white_logo.png', __FILE__), 30);

        // Create AWeber Settings Options.
        add_submenu_page('aweber.php', 'Settings', 'Settings', 'manage_options',
            'aweber.php', array(&$aweber_webform_plugin, 'printAdminPage'));

        // Create AWeber 'Forms' sub menu
        add_submenu_page('aweber.php', 'Forms', 'Forms', 'manage_options', 'aweber_web_form',
            array(&$aweber_webform_plugin, 'printSignupInfo'));
    }
}

if (!function_exists('AWeberRegisterSettings')) {

    function AWeberAuthMessage() {
        global $aweber_webform_plugin;
        if (isset($_GET['page']) && $_GET['page'] == 'aweber.php') {
            $aweber_webform_plugin->add_alert_message_html('negative', 'AWeber Sign Up Form requires authentication. Please follow below steps to connect to AWeber.', 'aweber-admin-notice');
        }
    }

    function AWeberRegisterSettings() {
        if (is_admin()) {
            global $aweber_webform_plugin;
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_webform_oauth_id');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_webform_oauth_removed');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_comment_checkbox_toggle');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_registration_checkbox_toggle');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_analytics_checkbox_toggle');

            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_comment_subscriber_text');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_register_subscriber_text');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_register_subscriber_listid');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_comment_subscriber_listid');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_comment_subscriber_tags');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_register_subscriber_tags');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_option_submitted');
            register_setting($aweber_webform_plugin->oauthOptionsName, 'aweber_oauth_error');

            $pluginAdminOptions = get_option($aweber_webform_plugin->adminOptionsName);
            if ($pluginAdminOptions['access_key'] == '') {
                add_action('admin_notices', 'AWeberAuthMessage');
                return;
            }
        }
    }
}
// Initialize widget.
if (!function_exists('AWeberFormsWidgetController_widget')) {
    function AWeberFormsWidgetController_widget() {
        global $aweber_webform_plugin;
        if (!isset($aweber_webform_plugin)) {
            return;
        }

        if (function_exists('wp_register_sidebar_widget') and function_exists('wp_register_widget_control')) {
            wp_register_sidebar_widget($aweber_webform_plugin->widgetOptionsName, __('AWeber Sign Up Form'), array(&$aweber_webform_plugin, 'printWidget'));
            wp_register_widget_control($aweber_webform_plugin->widgetOptionsName, __('AWeber Sign Up Form'), array(&$aweber_webform_plugin, 'printWidgetControl'));
        }
    }
}

if (!function_exists('AddAWeberShortCodes')) {
    function AddAWeberShortCodes() {
        // check user permissions
        if ( !current_user_can( 'edit_posts' ) &&  !current_user_can( 'edit_pages' ) ) {
            return;
        }
        // check if WYSIWYG is enabled
        if ( 'true' == get_user_option( 'rich_editing' ) ) {
            add_filter( 'mce_external_plugins', 'AddAWeberShortCodeScript' );
            add_filter( 'mce_buttons', 'RegisterAWeberShortCodeButton' );
        }
    }

    // register new button in the editor
    function RegisterAWeberShortCodeButton( $buttons ) {
        array_push( $buttons, 'aweber_shortcode_button' );
        return $buttons;
    }

    // declare a script for the new button
    // the script will insert the shortcode on the click event
    function AddAWeberShortCodeScript( $plugin_array ) {
        $plugin_array['aweber_shortcode_button'] = plugin_dir_url(__FILE__) . '/src/js/aweber_tinymce_shortcode_button.js';
        return $plugin_array;
    }
}

if (!function_exists('addAWeberBlockToGutenbergEditor')) {
    function addAWeberBlockToGutenbergEditor() {
        wp_register_script(
            'aweber-signupform-block',
            plugin_dir_url( __FILE__ ) . 'src/js/aweber_gutenberg_webform_block-react.js',
            array( 'wp-blocks', 'wp-element', 'wp-components', 'wp-editor', 'wp-i18n')
        );

        // Used to send the Data to the Javascript File.
        wp_localize_script( 'aweber-signupform-block', 'gutenberg_php_vars', array(
            'plugin_base_path'  => plugin_dir_url(__FILE__),
            'aweber_logo'       => plugin_dir_url(__FILE__) . 'AWeber_widget_blue.png'
        ));

        // Check the register_block_type function exists.
        if (function_exists('register_block_type')) {
            register_block_type( 'aweber-signupform-block/aweber-shortcode', array(
                'editor_script' => 'aweber-signupform-block',
            ));
        }
    }
}

if (!function_exists('registerAWeberElementorWidget')) {
    function registerAWeberElementorWidget() {
        require_once(dirname(__FILE__) . '/php/aweber_elementor_widget.php');

        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\AWeberElementorWidget() );
    }
}

if (!function_exists('registerAWeberFormAction')) {
    function registerAWeberFormAction() {
        require_once(dirname(__FILE__) . '/php/aweber_elementor_form_action.php');

        $aweber_action = new AWeberElementorFormAction();

        \ElementorPro\Plugin::instance()->modules_manager->get_modules( 'forms' )->add_form_action( $aweber_action->get_name(), $aweber_action );
    }
}

// Update CSS within in Admin
function load_admin_page_styles() {
    wp_enqueue_style( 'aweber_wp_admin_css', plugins_url('/src/css/aweber-plugin-styles.css', __FILE__), array(), '1.0.0');
    wp_enqueue_script( 'aweber_wp_admin_js', plugins_url('/src/js/aweber-plugin-script.js', __FILE__), array(), '1.0.0' );
    // Used to send the Data to the Javascript File.
    wp_localize_script( 'aweber_wp_admin_js', 'php_vars', array(
        'plugin_base_path'  => plugin_dir_url(__FILE__),
        'aweber_copy_png'   => plugin_dir_url(__FILE__) . 'assets/copy.png'
    ));
}

if (!function_exists('AWeberAdminFooterSettings')) {
    function AWeberAdminFooterSettings() {
        global $aweber_webform_plugin;

        $pluginAdminOptions = get_option($aweber_webform_plugin->adminOptionsName);
        if ($pluginAdminOptions['access_key'] == '' || !empty(get_option('aweber_oauth_error'))) {
            // Remove the Forms Submenu, Only if it is set.
            echo "<script>jQuery('#toplevel_page_aweber .wp-submenu > li :contains(Form)').parent().remove()</script>";
        }
    }
}

if (!function_exists('addAweberGoogleAnalyticsScripts')) {
    function addAweberGoogleAnalyticsScripts() { ?>
        <!-- AWeber Privacy Policy Link: https://www.aweber.com/privacy.htm -->
        <script async src="https://www.googletagmanager.com/gtag/js?id=UA-1759093-26"></script>
        <script>
            window.dataLayer = window.dataLayer || [];
            function gtag(){dataLayer.push(arguments);}
            gtag('js', new Date());
            gtag('config', 'UA-1759093-26');
        </script><?php
    }
}

// Actions and filters.
if (isset($aweber_webform_plugin)) {
    // Actions
    add_action('aweber/aweber.php',  array(&$aweber_webform_plugin, 'init'));
    add_action('admin_menu', 'AWeberFormsWidgetController_ap');
    add_action('admin_init', 'AWeberRegisterSettings');
    add_action('plugins_loaded', 'AWeberFormsWidgetController_widget');
    add_action('admin_print_scripts', array(&$aweber_webform_plugin, 'addHeaderCode'));
    add_action('wp_ajax_get_widget_control', array(&$aweber_webform_plugin, 'printWidgetControlAjax'));
    add_action('wp_dashboard_setup', array(&$aweber_webform_plugin, 'aweber_add_dashboard_widgets'));
    // Filters
    add_action('wp_enqueue_scripts', array(&$aweber_webform_plugin, 'loadAWeberPluginScripts'));
    // Ajax calls.
    add_action('wp_ajax_get_signup_webforms', array(&$aweber_webform_plugin, 'getSignupWebformsList'));
    add_action('wp_ajax_reload_aweber_cache', array(&$aweber_webform_plugin, 'reloadWidgetWebForm'));

    // Add AWeber ShortCode to Editor
    add_action('wp_ajax_get_aweber_webform_shortcodes', array(&$aweber_webform_plugin, 'getAWeberWebformShortCodes'));
    add_action('admin_head', 'AddAWeberShortCodes');

    // Add Block to Gutenberg editor
    add_action( 'init', 'addAWeberBlockToGutenbergEditor');

    // Add AWeber Signup form to Elementor Widgets
    if (in_array('elementor/elementor.php', apply_filters('active_plugins', get_option('active_plugins')))) {
        add_action('elementor/widgets/widgets_registered', 'registerAWeberElementorWidget');
        // Register AWeber for Custom Form Action
        add_action('elementor_pro/init', 'registerAWeberFormAction');
        // Register the Ajax call to get the lists
        add_action('wp_ajax_get_aweber_lists', array(&$aweber_webform_plugin, 'getAweberLists' ));
        // Register the Ajax call to get the lists
        add_action('wp_ajax_get_aweber_custom_fields', array(&$aweber_webform_plugin, 'getAWeberCustomFields'));
    }

    add_action( 'admin_footer', 'AWeberAdminFooterSettings');

    // Triggers teh AWeber ShortCode.
    add_shortcode('aweber', array(&$aweber_webform_plugin, 'aweberShortcodeHandler'));

    add_action('admin_enqueue_scripts', 'load_admin_page_styles');

    if (isset($_GET['page']) && in_array($_GET['page'], array('aweber.php', 'aweber_web_form'))) {
        add_action('in_admin_header', array(&$aweber_webform_plugin, 'attachAWeberheader'));
        // Add the Google analytics code only in the AWeber Wordpress Plugin pages.
        add_action('admin_head', 'addAweberGoogleAnalyticsScripts');
    }
}
?>
