<?php
    use AWeberWebFormPluginNamespace as AWeberWebformPluginAlias;

    $pluginAdminOptions = get_option($this->adminOptionsName);
    $options = get_option($this->widgetOptionsName);
    $account = null;
	$list_ids = array();

	if ($pluginAdminOptions['access_key']):
		try {
			$aweber = $this->_get_aweber_api($pluginAdminOptions['consumer_key'], $pluginAdminOptions['consumer_secret']);
			$account = $aweber->getAccount($pluginAdminOptions['access_key'], $pluginAdminOptions['access_secret']);

			$list_ids = $account->lists;
			// API is called, just to make sure that the connection with the AWeber exists.
            $sign_up_forms = $account->getWebForms();
		} catch (AWeberWebformPluginAlias\AWeberException $exc) {
			$error_ = get_class($exc);
			$error_code  = $exc->status;
			$description = $exc->getMessage();
			if (stripos($description, 'labs.aweber.com') !== false) {
				$description = preg_replace('/http.*$/i', '', $description);  # strip labs.aweber.com documentation url from error message
			}
			$account = null;
		} catch (AWeberWebformPluginAlias\AWeberAPIException $exc){
			$description = $exc->getMessage();
			$error_code  = $exc->status;
			if (stripos($description, 'labs.aweber.com') !== false) {
				$description = preg_replace('/http.*$/i', '', $description);  # strip labs.aweber.com documentation url from error message
			}
            $account = null;
        } catch (AWeberWebformPluginAlias\AWeberOAuthDataMissing $exc){
        	$account = null;
        } catch (\Exception $exc) {
        	$description = $exc->getMessage();
        	$account = null;
        }

        if (!$account):
        	if($error_ != null && $error_ != 'AWeberWebFormPluginNamespace\AWeberOAuthException' && $error_ != 'AWeberWebFormPluginNamespace\AWeberOAuthDataMissing') {
        		$this->displayCustomErrorMessages($error_code, $description);
        	} else {
        		$this->displayCustomErrorMessages($error_code, $description);
        		$this->deauthorize();
        	}
        endif;
    endif;
?>

<?php if($account): ?>
	<div class="aweber-wrapper">
		<div class="aweber-body-wrapper">
			<?php $this->add_alert_message_html('negative', '', 'aweber-hide aweber-forms-error-message'); ?>

			<div class="aweber-body">
				<h1 class="aweber-header-bar">Sign Up Forms</h1>

				<div class="list-dropdown">
					<label>List: </label>
					<select class="<?php echo $this->widgetOptionsName; ?>-list" data-type="sigup-form" name="<?php echo $this->widgetOptionsName; ?>[list]" id="<?php echo $this->widgetOptionsName; ?>-list">
						<?php foreach ($list_ids as $list): ?>
							<option <?php echo $options['selected_signup_form_list_id'] == $list->id ? 'selected' : '' ?> 
								value="<?php echo $list->id; ?>"><?php echo $list->name; ?></option>
				        <?php endforeach; ?>
					</select>
					<a type="button" href="https://www.aweber.com/users/web_forms/edit/" target="_blank" class="aweber-btn aweber-btn-success aweber-marginl10">Create</a>
				</div>

				<div class="signup-webform-list">
					<p>You do not have any Sign Up Forms for the selected list.</p>
				</div>
			</div>
		</div>

		<div class="aweber-body-wrapper">
			<div class="aweber-body">
				<h1 class="aweber-header-bar">Split Tests</h1>
				<div class="list-dropdown">
					<label>List: </label>
					<select class="<?php echo $this->widgetOptionsName; ?>-list" data-type="split-test" 
					name="<?php echo $this->widgetOptionsName; ?>[list]" id="<?php echo $this->widgetOptionsName; ?>-list">
						<option value="FALSE">Select A List</option>
						<?php foreach ($list_ids as $list): ?>
							<option <?php echo $options['selected_split_test_form_list_id'] == $list->id ? 'selected' : '' ?> value="<?php echo $list->id; ?>"><?php echo $list->name; ?></option>
				        <?php endforeach; ?>
					</select>
					<a type="button" href="https://www.aweber.com/users/web_form_splits/create/" target="_blank" class="aweber-btn aweber-btn-success aweber-marginl10">Create</a>
				</div>

				<div class="split-webform-list">
					<p>You do not have any Sign Up Forms for the selected list.</p>
				</div>
			</div>
		</div>
	</div>

	<div class="aweber-modal" id="show-form-locations">
		<div class="aweber-modal-content aweber-modal-lg">
			<div class="aweber-modal-header">
				<h1>Sign Up Form Locations</h1>
			</div>
			<div class="aweber-modal-body">
				<p>Modal body</p>
			</div>
			<div class="aweber-modal-footer text--xs-right">
				<button class="aweber-btn aweber-btn-primary aweber-dismiss-modal">Done</button>
			</div>
		</div>
	</div>
<?php endif; ?>
